Welcome to EMS DB Extract utility!

EMS DB Extract for SQL Server is a powerful and easy-to-use utility for creating database backups in the form of SQL scripts. It allows you to save metadata of all database objects as well as table data. The ability of flexible customization of the entire extract process allows you to select database objects and data tables for extraction and to define a number of extraction options. The distribution package of DB Extract for SQL Server includes a GUI wizard guiding you through the extraction process step by step, and a command-line service for creating backups quickly by using the console application which allows you to extract data in one-touch with script generation templates used.

Please visit our web-site available at http://www.sqlmanager.net/ for more information.

Key features

  • User-friendly graphical wizard interface
  • Extracting data from several tables of different databases located at one host within one session
  • The ability to select database objects for extraction
  • Extracting table data to SQL script as INSERT statements
  • The ability to define constraints for extracted data tables
  • The ability to insert statements for emptying tables before inserting extracted data
  • Saving all the extraction parameters specified within the current wizard session
  • The command-line utility to extract metadata and data with a previously created configuration file used
  • Multi-language GUI support

Product information

Homepage: | http://www.sqlmanager.net/en/products/mssql/extract
Support Ticket System: | http://www.sqlmanager.net/support
Register online at: | http://www.sqlmanager.net/en/products/mssql/extract/buy


What's new

Version | Release date
DB Extract for SQL Server 3.0.1.1 | September 30, 2011

What's new in DB Extract?

Data extraction:

  • Unicode support is implemented.
  • Data extraction speed is considerably increased.
  • Data from binary type fields used to be extracted improperly. Fixed now.

Metadata:

  • Unicode support in object descriptions, procedures, triggers bodies etc. is implemented.
  • SQL Server versions up to 2008 are now supported.
  • A number of new database and server objects are supported now.
  • Object dependencies extraction algorithm has been improved.
  • Metadata extraction speed is considerably increased.
  • Tables with foreign keys used to be extracted improperly. Fixed now.

File options:

  • Different charsets are now available for the result file.
  • Archives can now be split to volumes.
  • Added the ability to append current time, date or datetime to a path, archive, script or blob file name.
  • Templates with scheduled task options used to be saved incorrectly. Fixed now.

Interface:

  • The wizard window is now resizable.

Other minor fixes and improvements were made.

See also:

Version history


System Requirements

  • 300-megahertz (MHz) processor; 600-megahertz (MHz) or faster processor recommended
  • Microsoft® Windows NT4 with SP4 or later, Microsoft® Windows 2000, Microsoft® Windows 2000 Server, Microsoft® Windows XP, Microsoft® Windows 2003 Server, Microsoft® Windows 2008 Server, Microsoft® Windows Vista, Microsoft® Windows 7, Microsoft® Windows 8, Microsoft® Windows Server 2012
  • 64MB RAM or more; 128MB or more recommended
  • 20MB of available HD space for program installation
  • Super VGA (800x600) or higher-resolution video adapter and monitor; Super VGA (1024x768) or higher-resolution video adapter and monitor recommended
  • Microsoft® Mouse or compatible pointing device
  • Microsoft Data Access Components (MDAC) or SQL Server Native Client
  • Possibility to connect to any local or remote SQL Server™
  • Supported MS SQL Server versions: from 7.0 up to 2008


Installation

If you are installing DB Extract for SQL Server for the first time on your PC:

  • download the DB Extract for SQL Server distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • run MsExtractSetup.exe from the local directory and follow the instructions of the installation wizard;
  • after the installation process is completed, find the DB Extract shortcut in the corresponding group of Windows Start menu.

If you want to upgrade an installed copy of DB Extract for SQL Server to the latest version:

  • download the DB Extract for SQL Server distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • close DB Extract application if it is running;
  • run MsExtractSetup.exe from the local directory and follow the instructions of the installation wizard.

Also you can use the full distribution package to upgrade your current version of DB Extract for SQL Server. In this case, you should repeat the steps you have made for the first-time installation. Note that the full distribution package is larger than a single executable file.

See also:

System requirements


Registration

To make it easier for you to purchase our products, we have contracted with share-it! registration service. The share-it! order process is protected via a secure connection and makes on-line ordering by credit/debit card quick and safe. The following information about share-it! is provided for your convenience.

Share-it! is a global e-commerce provider for software and shareware sales via the Internet. Share-it! accepts payments in US Dollars, Euros, Pounds Sterling, Japanese Yen, Australian Dollars, Canadian Dollars or Swiss Franks by Credit Card (Visa, MasterCard/EuroCard, American Express, Diners Club), Bank/Wire Transfer, Check or Cash.

If you have ordered EMS software online and would like to review your order information, or if you have questions about ordering, payments, or shipping procedures, please visit our Customer Care Center, provided by Share-it!

Please note that all of our products are delivered via ESD (Electronic Software Delivery) only. After purchase you will be able to immediately download the registration keys or passwords and download links for archives of full versions. Also you will receive a copy of registration keys or passwords by e-mail. Please make sure to enter a valid e-mail address in your order. If you have not received the keys within 2 hours, please, contact us at sales@sqlmanager.net

Product distribution | Share It!
EMS DB Extract for SQL Server (Business license) + 1-Year Maintenance* | Buy Now!
EMS DB Extract for SQL Server (Business license) + 2-Year Maintenance*
EMS DB Extract for SQL Server (Business license) + 3-Year Maintenance*
EMS DB Extract for SQL Server (Non-commercial license) + 1-Year Maintenance*
EMS DB Extract for SQL Server (Non-commercial license) + 2-Year Maintenance*
EMS DB Extract for SQL Server (Non-commercial license) + 3-Year Maintenance*
EMS DB Extract for SQL Server (Trial version) | Download Now!

*EMS Maintenance Program provides the following benefits:

  • Free software bug fixes, enhancements, updates and upgrades during the maintenance period
  • Free unlimited communications with technical staff for the purpose of reporting Software failures
  • Free reasonable number of communications for the purpose of consultation on operational aspects of the software

After your maintenance expires, you will not be able to update your software or get technical support. To protect your investments and have your software up-to-date, you need to renew your maintenance.

You can easily reinitiate/renew your maintenance with our online, speed-through Maintenance Reinstatement/Renewal Interface. After reinitiating/renewal you will receive a confirmation e-mail with all the necessary information.

See also:

How to register EMS DB Extract


How to register EMS DB Extract

To register your newly purchased copy of EMS DB Extract for SQL Server, perform the following:

  • receive the notification letter from Share-it! with the registration info;
  • enter the Registration Name and the Registration Key from this letter;
  • make sure that the registration process has been completed successfully – check the registration information at the startup page.

hs1500 - Register product

See also:

Registration


Version history

Version | Release date
Version 2.2 | March 7, 2007
Version 2.1 | February 8, 2006
Version 2.0 | July 28, 2005
Version 1.2 | March 5, 2005
Version 1.1 | November 26, 2003
Version 1.0 | April 3, 2003

Full version history is available at http://www.sqlmanager.net/products/mssql/extract/news

Version 2.2

  • Objects extraction algorithm considering object dependencies has been improved
  • Extraction of BLOBs is now possible
  • The Delete records before insert option now uses the TRUNCATE TABLE statement to empty tables instead of the DELETE FROM statement used before
  • Considerably increased data extraction speed
  • A number of minor visual improvements

Version 2.1

  • Added the ability to extract privileges
  • Support of new object types implemented for the Specifying types of objects step of the Wizard
  • New saving template options contributing to more flexible work with templates
  • The Add PRINT <object name> statement before extraction option added at Step 6
  • The ability to extract dependent objects added

Scroll to top

Version 2.0

  • Completely rewritten source code
  • More user-friendly wizard interface
  • It has now become much more convenient to select objects for extraction: implemented an ability for multi-level grouping of objects by owners, schemas, databases, etc.; now you can select groups and separate records using drag-and-drop operations
  • Additional extract options implemented
  • Added an ability to define constraints on extracted table data
  • An ability to insert statements for emptying tables before inserting extracted data
  • Now it is possible to add current date to file and archive names; added an ability to save the files/archives to a folder with current date
  • Implemented an ability to add tasks to Windows Scheduled Task Manager (for Windows NT/2000/XP)
  • Added multi-language support and visual settings

Scroll to top

Version 1.2

  • Fixed a bug with loading the template when multiple databases were selected: in some cases the information about the database objects of the second used database was not loaded
  • Some minor visual improvements and bug-fixes

Scroll to top

Version 1.1

  • Added the Extract data from all tables option which can help you if you continuously change your database structure: you do not need to add new tables to your extraction template to extract data from them if this option is on
  • Added the Extract all objects option: use it to extract the entire database structure without adding each object to the extraction template
  • Now all objects of the selected type can be extracted: you can select the object types in Step 3 of the application Wizard
  • Implemented an ability to add extracted SQL scripts to a ZIP file
  • Wizard navigation has been significantly improved

Scroll to top

Version 1.0

Basic features:

  • Friendly user interface
  • Connecting to the server and selecting databases easily
  • Extracting metadata either from a single or from multiple databases at a time
  • Possibility of selecting the extracted database objects
  • Extracting table data to SQL script as INSERT statements with an opportunity to select data tables
  • Saving/loading templates with all the extract parameters and options
  • The console application for extracting metadata and data using the template file

and more...

Scroll to top

See also:

What's new


EMS DB Extract FAQ

Please read this page attentively if you have questions about EMS DB Extract for SQL Server.

Table of contents

  • What is MS SQL Extract utility?
  • What do I need to start working with MS SQL Extract?
  • What is the easiest way to configure template files for the console application of the extract utility?
  • What is the difference between the Extract Database function available in SQL Manager and the standalone Extract utility?
  • Are there any limitations implied in the trial version as compared with the full one?

Question/answer list

Q: What is MS SQL Extract utility?

A: EMS DB Extract for SQL Server is a powerful and easy-to-use utility for creating database backups in the form of SQL scripts. It allows you to save metadata of all database objects as well as table data. DB Extract for SQL Server includes a GUI wizard guiding you through the extract process step by step, and a command-line service for creating backups in one-touch.

Q: What do I need to start working with EMS MS SQL Extract?

A: First of all, you must have a possibility to connect to some local or remote SQL Server to work with MS SQL DB Extract. You can download SQL Server from http://www.microsoft.com/downloads/ (download is free). Besides, you need your computer to satisfy the system requirements of DB Extract for SQL Server. The utility runs on Windows NT4/2000/XP, CPU Pentium 166, 32 Mb RAM or higher is recommended.

Q: What is the easiest way to configure the template files for the MS SQL Extract console application?

A: You can configure the template files visually using the DB Extract wizard. Set the required extract options in all steps of the wizard and use the Tools | Save template menu item. All the options will be saved to a *.ext template file which can be used afterwards in the console application.

Q: What is the difference between the Extract Database function available in SQL Manager for SQL Server and the standalone Extract utility for SQL Server?

A: DB Extract for SQL Server includes some additional features which are not available in SQL Manager for SQL Server, such as:

  • console application allowing one to perform the extract operation in one-touch;
  • extracting metadata from several databases at one host;
  • faster execution speed.

Q: Are there any limitations implied in the trial version as compared with the full one?

A: Actually the trial version of the utility does not differ from the full version as far as the functionality is concerned. That is, you can test all the features implemented in DB Extract for SQL Server within the 30-day trial period.

Scroll to top

If you still have any questions, contact us at our Support Center.


Other EMS Products

Quick navigation

MySQL

Microsoft SQL Server

PostgreSQL

InterBase / FireBird

Oracle

IBM DB2

Tools & components

MySQL

 | SQL Management Studio for MySQL EMS SQL Management Studio for MySQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for MySQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for MySQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for MySQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for MySQL Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to MySQL.
datagenerator | Data Generator for MySQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for MySQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for MySQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for MySQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for MySQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Microsoft SQL Server

 | SQL Management Studio for SQL Server EMS SQL Management Studio for SQL Server is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for SQL Server Perform backup and restore, log shipping and many other regular maintenance tasks on the whole set of SQL Servers in your company.
sqladmin | SQL Administrator for SQL Server Perform administrative tasks in the fastest, easiest and most efficient way. Manage maintenance tasks, monitor their performance schedule, frequency and the last execution result.
 | SQL Manager for SQL Server Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for SQL Server Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for SQL Server Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for SQL Server Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to Microsoft® SQL Server™.
datagenerator | Data Generator for SQL Server Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for SQL Server Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for SQL Server Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for SQL Server Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for SQL Server Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

PostgreSQL

 | SQL Management Studio for PostgreSQL EMS SQL Management Studio for PostgreSQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for PostgreSQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for PostgreSQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for PostgreSQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for PostgreSQL Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, InterBase/Firebird, etc.) to PostgreSQL.
datagenerator | Data Generator for PostgreSQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for PostgreSQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for PostgreSQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for PostgreSQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for PostgreSQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

InterBase / Firebird

 | SQL Management Studio for InterBase/Firebird EMS SQL Management Studio for InterBase and Firebird is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for InterBase/Firebird Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for InterBase/Firebird Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for InterBase/Firebird Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for InterBase/Firebird Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, PostgreSQL, etc.) to InterBase/Firebird.
datagenerator | Data Generator for InterBase/Firebird Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for InterBase/Firebird Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for InterBase/Firebird Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for InterBase/Firebird Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for InterBase/Firebird Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Oracle

 | SQL Management Studio for Oracle EMS SQL Management Studio for Oracle is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for Oracle Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for Oracle Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for Oracle Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for Oracle Migrate from most popular databases (MySQL, PostgreSQL, MySQL, DB2, InterBase/Firebird, etc.) to Oracle
datagenerator | Data Generator for Oracle Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for Oracle Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for Oracle Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for Oracle Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for Oracle Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

IBM DB2

 | SQL Manager for DB2 Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for DB2 Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for DB2 Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for DB2 Migrate from most popular databases (MySQL, PostgreSQL, Oracle, MySQL, InterBase/Firebird, etc.) to DB2
datagenerator | Data Generator for DB2 Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
extract | DB Extract for DB2 Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for DB2 Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
 | Scroll to top

Tools & components

advancedexport | Advanced Data Export Advanced Data Export Component Suite for Borland Delphi and C++ Builder will allow you to save your data in the most popular office programs formats.
advancedexport | Advanced Data Export .NET Advanced Data Export .NET is a component suite for Microsoft Visual Studio .NET that will allow you to save your data in the most popular data formats for the future viewing, modification, printing or web publication. You can export data into MS Access, MS Excel, MS Word (RTF), PDF, TXT, DBF, CSV and more! There will be no need to waste your time on tiresome data conversion - Advanced Data Export will do the task quickly and will give the result in the desired format.
advancedimport | Advanced Data Import Advanced Data Import™ Component Suite for Delphi and C++ Builder will allow you to import your data to the database from files in the most popular data formats.
pdfgenerator | Advanced PDF Generator Advanced PDF Generator for Delphi gives you an opportunity to create PDF documents with your applications written on Delphi or C++ Builder.
querybuilder | Advanced Query Builder Advanced Query Builder is a powerful component suite for Borland Delphi and C++ Builder intended for visual building SQL statements for the SELECT, INSERT, UPDATE and DELETE clauses.
excelreport | Advanced Excel Report Advanced Excel Report for Delphi is a powerful band-oriented generator of template-based reports in MS Excel.
advancedlocalizer | Advanced Localizer Advanced Localizer™ is an indispensable component suite for Delphi for adding multilingual support to your applications.
 | Scroll to top


Wizard application

The GUI application of DB Extract for SQL Server provides easy-to-use wizard interface to set all extraction parameters visually.

Using wizard application

Using configuration files

Setting program preferences

hs2000 - Wizard application

See also:

Console Application


Using wizard application

Follow the steps of the wizard to extract metadata and data of your SQL Server database easily and quickly:

Getting started

Step 1 - Setting connection properties

Step 2 - Selecting databases for extraction

Step 3 - Specifying types of objects

Step 4 - Selecting objects for metadata extraction

Step 5 - Selecting tables for data extraction

Step 6 - Setting up extraction options

Step 7 - Specifying file names and directories

Step 8 - Scheduling options

Step 9 - Start of extraction process

See also:

Using console application


Getting started

This is how DB Extract for SQL Server wizard application looks when you first start it.

This page allows you to view general information about the software product: Homepage address, the link to the online Support Ticket System, the version of the utility, registration information.

hs2101 - Getting started

Press the Next button to proceed to Step 1 of the wizard.

See also:

Registration


Step 1 - Setting connection properties

At this step you should enter the necessary settings to establish connection to SQL Server.

hs2103 - Step1 - Setting connection properties

First select the connection type: local or remote.

Local connection is used to connect to SQL Server launched on the same machine where DB Extract for SQL Server is running.

The Remote mode allows you to connect to SQL Server launched on another computer in the network.

By default the program uses local connection. It is indicated by switch Local selected. If you wish to establish remote connection, you should select the Remote switch. For remote connection you should also enter SQL Server host name in the Host field.

Please note that if Microsoft® SQL Server™ is installed as a named instance, you should specify 'Remote' as the connection type and enter the name of your machine and the instance name in the 'Host' field in the following format: computer_name\sqlserver_instance_name (e.g. "MYCOMPUTER\SQLEXPRESS").

Authentication Type

Specify the type of SQL Server authentication to be used for the connection: SQL Server or Windows authentication. It is strongly recommended to avoid using SQL Server authentication with "sa" as the login.

If SQL Server has been selected as the authentication type, you should also provide authorization settings: Login and Password.

If you are using the EMS SQL Management Studio for SQL Server version of DB Extract for SQL Server then the Select registered database button is available. Click this button to pick a database already registered in the EMS SQL Management Studio in the Select Host or Database dialog.

When you are done, press the Next button to proceed to the next step of the wizard.


Selecting registered database

Use this dialog to select a database for extract. This dialog is available only in EMS SQL Management Studio version of DB Extract for SQL Server.

Selecting registered database

All databases registered in EMS SQL Management Studio for SQL Server are displayed in the list.

Select the necessary database and click the OK button.

Database registration information will be filled on the first step automatically.


Step 2 - Selecting databases

At this step you should select the database(s) from which metadata and/or data are to be extracted.

In the Available Databases list you can see all the databases which are available on the server. To select databases for extraction, move them to the Selected Databases list. To cancel a database selection, just remove it from the Selected Databases list. Use the Move to Selected Move to Available Move all to Selected Move all to Available buttons or drag-and-drop operations to move the databases from one list to another.

Hint: To select multiple databases, hold down the Shift or Ctrl key while selecting the database names.

hs2105 - Step2 - Selecting databases

When you are done, press the Next button to proceed to the next step of the wizard.


Step 3 - Specifying types of objects

At this step you can define types of objects for metadata and data extraction.

Extract options

This group allows you to choose whether metadata only, data only or both are to be extracted.

hs2107 - Step3 - Specifying types of objects

Metadata options

This group of options is only enabled for the RadioButton Extract metadata only and the RadioButton Extract both structure and data previously selected Extract options. Using options of this group you can either specify all objects or define particular types of objects to extract metadata from. For your convenience the Invert selection, Unselect all and Select all functions are implemented as the corresponding buttons. These functions are also available from the context menu of the objects list area.

Step 3 - Context menu

Data options

This group of options is only enabled for the RadioButton Extract data only and the RadioButton Extract both structure and data previously selected Extract options.

Here you should specify whether data are to be extracted from all tables or from the selected ones only.

When you are done, press the Next button to proceed to the next step of the wizard.

Depending on whether you have specified Extract all objects / Extract all data tables in the Metadata Options and the Data Options groups correspondingly, you will either proceed to the next step of the wizard, or you will be immediately forwarded to the Selecting tables for data extraction or the Setting up extraction options wizard steps.


Step 4 - Selecting objects for metadata extraction

At this step you should select the objects from which metadata is to be extracted.

hs2109 - Step4 - Selecting objects for metadata extraction

In the Available objects tree you can see the objects which have been selected for metadata extraction at the Specifying object types step. Initially the objects are grouped by database names and object types. You can change grouping by dragging column headers to the grey upper area or cancel grouping by dragging them back. Additionally, you can use the Custom Filter dialog allowing you to set conditions for filtering objects in the trees.

hs2109 - Step4 - Custom Filter

To select objects, move the items from the Available objects tree to the Selected objects tree. To cancel object selection, just remove it from the Selected objects tree. Use the Move to Selected Move to Available Move all to Selected Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Hint: To select multiple objects, hold down the Shift or Ctrl key while selecting the object names.

The context menus of the Available objects and the Selected objects areas allow you to browse the objects in the tree more effectively: you can expand/collapse objects viewed in the tree or specify filter conditions within the Filter builder dialog.

Step 4-5 - Context Menu

The Filter builder dialog allows you to facilitate creating and applying filter criteria for the objects viewed in the trees. It is also possible to save filter criteria to an external *.flt file and load them from that file any time afterwards by using the Save as... and the Open... buttons.

hs2109 - Step4 - Filter Builder

When you are done, press the Next button to proceed to the next step of the wizard.

Depending on whether you have specified Extract all data tables in the Data Options group at the Specifying object types step, you will either proceed to the next step of the wizard, or you will be immediately forwarded to the Setting up extraction options wizard step.


Step 5 - Selecting tables for data extraction

At this step you should select the tables from which data is to be extracted.

hs2111 - Step5 - Selecting tables for data extraction

In the Available data tables tree you can see the tables belonging to the databases specified at the Selecting objects for metadata extraction step. Initially the tables are grouped by DB names and schemas. You can change grouping by dragging column headers to the grey group boxes above the grids or ungroup them by dragging to the grid headers. Additionally, you can use the Custom Filter dialog allowing you to set conditions for filtering data tables in the trees.

hs2111 - Step5-6 - Custom Filter

To select tables, move the items from the Available data tables tree to the Selected data tables tree. To cancel table selection, just remove it from the Selected data tables tree. Use the Move to Selected Move to Available Move all to Selected Move all to Available buttons or drag-and-drop operations to move the tables from one list to another.

Hint: To select multiple tables, hold down the Shift or Ctrl key while selecting the table names.

The context menus of the Available data tables and the Selected data tables areas allow you to browse the tables in the tree more effectively: you can expand/collapse the tables viewed in the tree or specify filter conditions within the Filter Builder dialog.

Step 4-5 - Context Menu

The Filter Builder dialog allows you to facilitate creating and applying filter criteria for the tables viewed in the trees. It is also possible to save filter criteria to an external *.flt file and load them from that file any time afterwards by using the Save as... and the Open... buttons.

hs2111 - Step5-6 - Filter Builder

When you are done, press the Next button to proceed to the next step of the wizard.


Step 6 - Setting up extraction options

At this step you can set the advanced extraction parameters and define query options for data extraction.

Metadata options

CheckBox Generate "CREATE DATABASE" statements

Check this option to add the CREATE DATABASE statement(s) to the extraction script.

CheckBox Generate "USE DATABASE" statement

Check this option to add the USE DATABASE statement(s) to the result script.

CheckBox Generate "DROP" statements

Check the option to add the DROP statements for the extracted objects.

CheckBox With "IF" statements

Check this option to add the IF keyword to the DROP statements in the result script.

CheckBox Create empty procedures

This option specifies whether procedures with empty bodies are included in the result script or not.

CheckBox Extract privileges

Tick off the option if you want the privileges (permissions on the objects) to be extracted.

CheckBox Order by dependencies

This option specifies whether objects should be ordered by their dependencies in the result script or not.

CheckBox Extract dependent objects

This option determines the usage of dependencies between objects in the extraction process.

CheckBox Extract dependent tables data

Enable this option to extract the data of the dependent tables to the result script.

CheckBox Use collations

This option determines the usage of collations in the extraction process.

hs2113 - Step6 - Setting up extraction options

Data options

Records in block / CheckBox Insert "COMMIT" after each block

These controls allow you to define whether the COMMIT statement is inserted into the script or not, and to define the number of records in each block to be supplemented with this statement.

CheckBox Delete existing records before insert

Generates the TRUNCATE TABLE statements before the INSERT INTO statements.

CheckBox Generate "PRINT <object name>" statement

Check this option to allow adding the PRINT statement to the result script.

Data query options

This grid allows you to specify additional options for the SELECT statements used for data extraction.

Database name

This column represents the list of the databases containing the tables selected for data extraction.

Limit data

By setting non-zero values in this column you can limit the number of records extracted from each table.

Table name

This column contains the names of the tables (with the names of the schemas they belong to).

Table data filter

Here you can specify the WHERE clauses for data extraction from each of the tables.

Note that you can define data query options not only for a single table, but also for multiple tables at a time by using corresponding items of the context menu of the Data query options grid.

Step 6-7 - Context menu

When you are done, press the Next button to proceed to the next step of the wizard.


Step 7 - Specifying file names and directories

At this step you should specify the file name and the directory where the result script will be saved.

Directory options

Default directory

Type in the path or use the btnOpenFile button to specify the default directory for the result files to be placed in.

CheckBox Add to path

Check this option to add current date, time or datetime (can be specified at the corresponding drop-down list) to the folder name.

hs2115 - Step7 - Specifying file names and directories

File options

This group of options allows you to specify whether the source databases are to be placed into a single SQL script file or divided into several files of smaller size, each for a separate extracted database. This option is only available if objects from several databases have been specified for extraction.

File name

Set a name for the result *.sql file and type in or use the btnSaveAs button to specify the path to this file on your local machine or on a machine in the LAN.

CheckBox File charset

Choose the necessary charset for the file.

CheckBox Add to name

Check this option to add current date, time or datetime (can be specified at the corresponding drop-down list) to the filename.

Compression options

CheckBox Compress files

Check this option if you wish to add the result SQL script to a ZIP file.

CheckBox Single archive file

Check this option to indicate whether the result SQL script is to be placed into a single ZIP archive file or divided into several archive files of smaller size, each for a separate extracted database. This option is only available if objects from several databases have been specified for extraction.

Archive file name

Set a name for the compressed *.zip file and type in or use the btnSaveAs button to specify the path to this archive file on your local machine or on a machine in the LAN.

CheckBox Add to name

Check this option to add current date, time or datetime (can be specified at the corresponding drop-down list) to the archive filename.

Split to volumes

If compression in a single archive is enabled you can split the archive to volumes of defined size. The size of an archive volume is in bytes by default, kilobyte if the value is followed by 'K' and megabyte if the value is followed by 'M'.

BLOB options

In this group of options you can determine whether BLOB fields are not to be extracted, extracted as strings, or extracted into a separate file. If the latter is selected, you also need to specify the File name (the *.blo file where the BLOB data are to be stored) and the location of the file on your local machine using the btnSaveAs button.

Note: The SET BLOBFILE statement will be added to the result script when extracting the BLOB fields into a file. This statement is correctly executed only in EMS products.

CheckBox Compression

Check this option if you wish to compress the file containing BLOB data.

Compression Level

Define the desired compression level to be applied for the file: None (selected by default), Normal, Fastest, Best.

CheckBox Add to name

Check this option to add the current Date, Time or both to the specified name.

File names

This grid allows you to view the summary of the result *.sql and *.zip files selection.

Database name

This column represents the databases corresponding to the specified *.sql (*.zip) files (if the RadioButton Separate file for each database option has been selected).

SQL file name

This column represents the list of *.sql files, each for a separate extracted database.

Archive name

This column represents the list of *.zip archive files, each for a separate extracted database.

When you are done, press the Next button to proceed to the next step of the wizard.


Step 8 - Scheduling options

At this step you can setup scheduled execution of the extraction task with DB Extract command-line service used.

Scheduled execution options

Choose here if the extraction task is to be run within the current session of the GUI wizard, or whether the task is to be scheduled for running later, or both.

Recurrence rule

Set the Run once option to execute the extraction task one time, or select a RadioButton daily, a RadioButton weekly or a RadioButton monthly Recurrence Rule to repeat the extraction task periodically.

hs2117 - Step8 - Scheduling options

Task options

Scheduled time

This box allows you to set the time of the task execution.

Scheduled date

This box allows you to set the date of the extraction task execution if the Recurrence Rule is set to Run once.

Please note that this value cannot be greater than one month forward.

CheckBox Do not close console window after execution

This option is used to disable/enable closing the console window after the scheduled extraction is complete.

Note: You must have the Task Scheduler service running to be able to use these settings. Please open Windows Control Panel | Administrative Tools | Services (or open the Start | Run... dialog and use the services.msc command) to start the Task Scheduler service.

Weekly task / Monthly task

These groups contain the lists of days of the week/month that can be set for the extraction task to be executed (applied when the Recurrence Rule is set to weekly or monthly)

CheckBox Generate a separate task for each day

Check this option if you want several tasks (each corresponding to the specified day) to be created for Windows Task Scheduler.

Execute as...

In these fields you must specify Windows Domain (if a domain login is being used), User name and User password for the task execution. It is recommended to run the task as current Windows user.

When you are done, press the Next button to proceed to the last step of the wizard.


Step 9 - Start of extraction process

This step is aimed at informing you that all the extraction parameters are set, and you can now start the extraction process.

Script options

CheckBox Abort extraction on error

This option determines whether the extraction process should be stopped or forced to continue if an error occurs.

CheckBox Show comments in script

Set this option to allow adding comments on the extraction process to the result SQL script.

If all necessary DB Extract settings are specified correctly, press the Extract button to start the process. If you want to change something, you can return to any of the wizard steps using the Back button.

hs2119 - Step9 - Start of extraction process

Please do not forget to save the extraction options if you intend to repeat the extraction process with the same or similar settings later.

While the extraction process you can use the Send to background button to reduce the priority of the extraction operation, the Cancel button to interrupt the process and the Minimize button to to minimize the utility window.

See also:

Using configuration files

Setting program preferences


Using configuration files

DB Extract for SQL Server allows you to store its configuration in external *.ext files if you need to repeat the extraction process many times.

You can load the previously saved configuration to the wizard application if you need to make some changes before extraction, or you can run it with the console application for quicker extraction.

  • Saving configuration file
  • Loading configuration file

See also:

Using wizard application

Setting program preferences


Saving configuration file

The Save template item allows you to save current configuration for future use.

Please note that a configuration file (template) can be saved only on Step 7 and the succeeding steps of the wizard.

hs2210 - Saving template

Save template options:

File name

Specify the template file name and select its location using the btnSaveAs button to open the Save As... dialog.

Comment

If necessary, set a comment for your template file in this field.

hs2210 - Template options

See also:

Loading configuration file


Loading configuration file

Previously saved DB Extract templates are loaded within the Open template dialog. To call this dialog, press the Tools button and select the Load template popup menu item.

hs2220 - Loading template

Please note that you can reopen a template at any step of the wizard using the corresponding popup menu item of the Tools menu.

See also:

Saving configuration file


Setting program preferences

DB Extract for SQL Server provides full customization of the program interface by setting various options within the Preferences dialog. This chapter is intended to inform you how to use these options.

General options

These options define general behavior of DB Extract for SQL Server

Localization

This page allows you to select a language to be applied for your copy of DB Extract for SQL Server.

Interface

This branch contains several pages with a number of options allowing you to customize the application interface style according to your liking.

hs2300 - Preferences

See also:

Using wizard application

Using configuration files


Setting general options

CheckBox Show database list

If this option is checked, all databases available on the host are displayed in the Available Databases list at Step 2 of the wizard, and you can select databases from the list to add them to the Selected Databases list. Otherwise you must type the database name manually and add them to the Available Databases list one by one using the btnAddDatabaseToDBList button.

CheckBox Remember password

Setting this option allows you to save passwords used for access to the database server automatically upon closing the application. Please note that checking this option saves the latest password used for connection to the database

CheckBox Confirm exit

Enables/disables confirmation upon exiting the program.

CheckBox Save current options on exit

Setting this option allows you to save all the extraction options automatically upon exiting the application.

CheckBox Save password and user name for Scheduled Task creation

Set this option to remember Windows login information provided for the scheduled task execution.

hs2310 - Setting general options

See also:

Setting program language

Defining interface style


Setting program language

The Localization page is provided for DB Extract for SQL Server interface localization files management.

You can create your own *.lng files similar to those available in the %program_directory%\Languages folder, add them to the list of the available languages and apply a new language as the program interface language.

Default directory

Use the btnOpenFile button to specify the directory where the *.lng files are stored by default.

Choose program language

Select the language you wish to be applied to the GUI application from the drop-down list of available languages.

In the Available Languages area the list of available languages and the names of the corresponding localization (*.lng) files are displayed. You can manage the list of the languages using the buttons below.

hs2320 - Setting program language

Add defaults

Adds languages from the default directory to the list of available languages.

Add

Opens the Add language dialog where you can specify your own localization file and set the language name.

hs2320 - Add language

Edit

Opens the Edit language dialog where you can change the language name or select another localization file for the specified language.

hs2320 - Edit language

Delete

Removes the selected language from the Available languages list (without confirmation).

See also:

Setting general options

Defining interface style


Defining interface style

This page allows you to customize the application interface style according to your liking.

Use the Scheme name drop-down list to select an interface scheme according to your liking: Classic, Office XP style, Windows XP native style, etc.

hs2330 - Defining interface style

It is also possible to create one's own interface scheme, if necessary:

  • set your preferences within the available branches of the Interface node (Trees and Lists, Edit Controls, Check Boxes, Buttons, Group Boxes);
  • return to the Interface page and click the Save As button;
  • specify the scheme name in the Input scheme name dialog.

hs2330 - Input scheme name

Note: For your convenience the previews illustrating the changes are displayed in the Sample group area of each branch of the Interface node.

See also:

Setting general options

Setting program language


Console application

Additionally to the GUI version which is implemented in the form of a wizard application, the installation package of DB Extract for SQL Server includes the console version which is intended for being run from Windows command line with a template file name used as the execution parameter.

hs3000 - Console application

DB Extract for SQL Server command line utility is intended for quick and powerful metadata and data extraction from SQL Server databases.

  • Using console application
  • Configuration file format

See also:

Wizard application


Using console application

All the extraction options are set in template (*.ext) files. A template can be also used in the Console version of DB Extract for SQL Server

To create a template file, follow the instructions below:

  • start DB Extract for SQL Server Wizard application;
  • set all the required options in all steps of the wizard;
  • test the extraction process at the last step;
  • save all generation options in the template file.

The easiest way to start DB Extract for SQL Server console application is to double-click the generated *.ext configuration file. The other way is to enter the command line and type the appropriate command.

Usage:

<path to DB Extract for SQL Server console application>\MsExtractC.exe TemplateFile [-L] [-B]

TemplateFile

Stands for the *.ext template file to be used as the console version execution parameter

[-L]

Selects current localization set in Wizard application (GUI)

[-B]

Use this parameter in the command line to run the console version of DB Extract for SQL Server in background mode

Example:

"C:\Program Files\EMS\MS SQL Extract\MsExtractC.exe" "C:\Program Files\EMS\MS SQL Extract\DBExtract1.ext" -L

Note: The following exit codes can be returned by DB Extract for SQL Server to the operating system after performing the latest task:

0 - successful completion;

1 - error(s) occurred during task performing;

2 - fatal error occurred. The task was not performed.

See also:

Using wizard application

Configuration file format


Configuration file format

DB Extract configuration file is divided into several sections, each corresponding to a particular group of settings specified on different steps of the GUI application.

  • General and Connection sections
  • Common options section
  • Extract options section
  • File options section
  • Scheduled task sections
  • Data query sections
  • Databases section

See also:

Using console application


General and Connection sections

The very first section of DB Extract configuration file is [#General#] - the product name and its major version are indicated in this section.

The [#Connection#] section corresponds to the values entered on Step 1 of Wizard application.

The configuration parameters are listed below.

The section contains database connection parameters: Host, Login and Password. These parameters are obligatory.

Remote

0 = local connection

1 = remote connection

NTAuth

1 = Windows authentication

0 = SQL Server authentication

See also:

Common Options section

Extract Options section

File Options section

Scheduled Task sections

Data Query sections

Databases section


Common Options section

Section [#Options#] represents the options corresponding to those specified on Step 3 of Wizard application.

The configuration parameters are listed below.

ExtractOptionsIndex

0 = Extract both structure and data

1 = Extract metadata only

2 = Extract data only

ExtractAllMetaObjects

0 = Extract selected types of objects only

1 = Extract all objects

ExtractMetadataFrom (applicable if ExtractAllMetaObjects = 0)

The value of this option is a list of zero ("0") and one ("1") values

Each value corresponds to a certain object type in the order they are listed on Step 3:Tables, Views, Procedures, UDTs, Users, Roles, Defaults, UDFs, Rules, Schemas, Assemblies, XML schema collections, Synonyms, Database triggers, Partition functions, Partition schemes, Aggregates, Symmetric keys, Asymmetric keys, Certificates, Full-text catalogs, Message types, Contracts, Services, Routes, Remote service bindings, Logins, Backup devices, Jobs, Alerts, Operators, Linked servers, Shared schedules, Proxies, Credentials, Endpoints, Server triggers

ExtractAllData

0 = Extract selected data tables

1 = Extract all data tables

The following two options correspond to the last step of the GUI application.

AbortOnError

0 = Do not abort script execution if an error occurs during execution

1 = Abort script execution on error

InsertComments

0 = Do not add comments to the result script

1 = Allow adding comments to the result script

See also:

General and Connection sections

Extract Options section

File Options section

Scheduled Task sections

Data Query sections

Databases section


Extract Options section

Section [#ExtractOptions#] stores values set on Step 6 of Wizard application.

The configuration parameters are listed below.

CreateDatabaseStmt

0 = Do not add CREATE DATABASE statement to the extraction script.

1 = Add CREATE DATABASE statement to the extraction script.

DropTableStmt

0 = Do not add DROP statements for the extracted objects

1 = Add DROP statements for the extracted objects to the result script

RecordsInBlock

The number of INSERT statements in a block after which the COMMIT statement is to be added

InsertCommit

0 = Do not insert COMMIT statement after each block

1 = Insert COMMIT statement after each block

DeleteAllRecords

0 = Do not delete any records from the tables before the INSERT statements

1 = Delete all records from the tables before the INSERT statements

Privileges

0 = Do not include access privileges for the extracted objects

1 = Include access privileges for the extracted objects

BlobExtractType

0 = Do not extract BLOB fields

1 = Extract BLOB fields to strings

2 = Extract BLOB fields into file

BlobSingleFile

0 = BLOB fields will be extracted into a number of files

1 = BLOB fields will be extracted into a single file

BlobComressionLevel

0 = None

1 = Fastest

2 = Normal

3 = Best

AddDateTimeToBlob

0 = Do not add the current date and time to BLOB filename(s)

1 = Add the current date and time to BLOB filename(s)

AddDateTimeTypeBlob

0 = Date will be added to BLOB filename(s)

1 = Time will be added to BLOB filename(s)

2 = Datetime will be added to BLOB filename(s)

AddUse

0 = Do not add the USE DATABASE statement to the beginning of the script

1 = Add the USE DATABASE statement to the beginning of the script

PrintObjectName

0 = Do not add PRINT <object name> statement before extraction

1 = Add PRINT <object name> statement before extraction

UseCollations

0 = Do not use collations for the extraction process

1 = Use collations for the extraction process

See also:

General and Connection sections

Common Options section

File Options section

Scheduled Task sections

Data Query sections

Databases section


File Options section

Section [#FileOptions#] stores values set on Step 7 of Wizard application.

The configuration parameters are listed below.

SingleFile

0 = Create a separate file for each of the databases (see Databases section)

1 = All metadata and data are extracted into one file

SingleFileName

Stores the file name (if SingleFile = 1)

AddDateTimeToFile

0 = Do not add the current date and time to the file name(s)

1 = Add the current date and time to the file name(s)

AddDateTimeTypeFile

0 = Date will be added to the filename

1 = Time will be added to the filename

2 = Datetime will be added to the filename

CompressFiles

0 = Do not compress files

1 = Compress files

SingleArchiveFile

0 = Create separate archive file for each of the databases (see Databases section)

1 = Compress all the script files into a single archive file

SingleArchiveFileName

File name (if SingleArchiveFile = 1)

SingleArchiveVolumeSize

Sets the size of an archive volume in bytes by default, kilobyte if the value is followed by 'K' and megabyte if the value is followed by 'M'.

AddDateTimeToArc

0 = Do not add the current date and time to the archive name(s)

1 = Add the current date and time to the archive name(s)

AddDateTimeTypeArc

0 = Date will be added to the archive name

1 = Time will be added to the archive name

2 = Datetime will be added to the archive name

InitialDir

The path to the directory where the script files are to be saved by default

AddFolderWithDate

0 = Do not create a folder with the current date and time as the name inside the default directory (which is specified in the InitialDir parameter)

1 = Create a folder with the current date and time as the name inside the default directory (which is specified in the InitialDir parameter)

AddDateTimeTypeFolder

0 = Date will be added to the folder name

1 = Time will be added to the folder name

2 = Datetime will be added to the folder name

See also:

General and Connection sections

Common Options section

Extract Options section

Scheduled Task sections

Data Query sections

Databases section


Scheduled Task sections

Section [#ScheduledTask#] stores values set on Step 8 of Wizard application.

The configuration parameters are listed below.

TaskType

0 = Run the scheduled task once

1 = Run the scheduled task daily

2 = Run the scheduled task weekly

3 = Run the scheduled task monthly

ScheduledPrefIndex

0 = Run extraction now

1 = Run extraction now and create Windows scheduled task

2 = Create Windows scheduled task only

SchellTime

Stores the scheduled task execution time

ScheduledDate

Stores the scheduled task execution date (applicable only for TaskType = 0)

WeeklyList

The days of the week when the task is scheduled to run (applicable only for TaskType = 2)

The value of this option is a list of zero ("0") and one ("1") values

Each value corresponds to a certain day of the week in the following order:

Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, Sunday

e.g. WeeklyList=1,0,0,0,1,0,0 indicates running scheduled task weekly on Mondays and Fridays

DaysList

The days of the month when the task is scheduled to run (applicable only for TaskType = 3)

The value of this option is a list of zero ("0") and one ("1") values

Each value corresponds to a certain day of the month in the calendar order

SeparateTask (applicable only for TaskType = 3)

0 = Create a single scheduled task for all selected days of the month

1 = Create a separate scheduled task for each selected day of the month

TaskDomain

Windows domain of the user specified to run the scheduled task

TaskUserName

Windows user name specified to run the scheduled task

TaskPassword

Windows user password specified to run the scheduled task

NotCloseConsole

0 = Close the console window after execution of the scheduled task

1 = Do not close the console window after execution of the scheduled task

Section [#Comment#] stores your comment for the template file

e.g. Line0 = Template1 for metadata and data extraction

See also:

General and Connection sections

Common Options section

Extract Options section

File Options section

Data Query sections

Databases section


Data Query sections

The following two sections of the template store data query options set on Step 6 of Wizard application.

The configuration parameters are listed below.

[#Limits#]

Stores parameters in the following format: <database name>.<schema name>.<table name> = <records limit>

[#WhereClauses#]

Stores parameters in the following format: <database name>.<schema name>.<table name> = <WHERE clause>

See also:

General and Connection sections

Common Options section

Extract Options section

File Options section

Scheduled Task sections

Databases section


Databases section

This section of DB Extract template contains the list of the database objects specified for extraction, and particular extraction parameters.

The configuration parameters are listed below.

OutputFileName

The name of the result *.sql script file (if SingleFile = 0, see File Options section)

ArchiveFileName

The name of the result *.zip archive file (if SingleArchiveFile = 0, see File Options section)

The list of the objects specified for extraction is represented in the following format:

<ObjectType>Count

Stores the number of selected objects of this type, or equals to the 'ALL' string value (which means that all objects of this type are to be extracted)

TablesXX

Each parameter of this type stores the name of the table specified for metadata extraction (XX stands for the table unique identifier, e.g. Tables0 = TestDB.dbo.Account)

The list of objects that are included into the databases section is taken from the ExtractMetadataFrom parameter value (see Common Options section and Step 3 of the GUI application)

Next is list of tables to extract their data in the following format.

DataTablesCount

Stores the number of tables specified for data extraction, or equals to the 'ALL' string value (which means that data from all tables of the database are to be extracted)

DataTablesXX

Each parameter of this type stores the name of the table specified for data extraction (XX stands for the table unique identifier, e.g. DataTables0 = TestDB.dbo.Address)

See also:

General and Connection sections

Common Options section

Extract Options section

File Options section

Scheduled Task sections

Data Query sections


Advanced connectionon settings

You need the installed Oracle client on the client computer where DB Extract for SQL Server will be used. The version of the Oracle client should be compatible with the version of Oracle server you need to connect.

You need to add the connection settings of Oracle server databases to your TNS names file (tnsnames.ora file). This is a configuration file which contains databases description.

If you use Database Client the tnsnames.ora file is located in the %HOME_name\NETWORK\ADMIN directory.

If you use Instant Client for oracle, you should create tnsnames.ora file manually. since it does not exist. File should be created in the same directory where Oracle instant client is installed (e.g. C:\OracleInstantClient\). This file can be created using any text editor (create a simple text file and then change its name and extension).

Only for Instant Client: After the tnsnames.ora file is created and database description is added, create TNS_ADMIN environment variable. For this please do the following:

  1. Right-click 'My computer'.
  2. Select 'Properties' menu item.
  3. Proceed to the 'Advanced' tab and press 'Environment Variables' button.
  4. Press 'New...' button in the 'System variables' section.
  5. Set 'Variable name:' TNS_ADMIN, 'Variable value:' C:\OracleInstantClien\tnsnames.ora
  6. Press 'OK' button to save the variable.

Find PATH variable in the same dialog, double-click it and add path to the Oracle Instant client libraries (they are located in the directory where client is installed, i.e. C:\OracleInstantClient\). Remember that the paths entries should be separated with semicolons ( ; ).

DB Extract for SQL Server connects to the server (with the help of Oracle client) via TCP/IP protocol. Here is an example of TCP/IP connection specified in TNS names file:

DB_Alias =

(DESCRIPTION =

(ADDRESS_LIST =

(ADDRESS = (PROTOCOL = TCP)(HOST = Host_name)(PORT = 1521))

)

(CONNECT_DATA =

(SERVER = DEDICATED)

(SERVICE_NAME = Database_Name)

)

)

PROTOCOL is the keyword that identifies the specific protocol adapter used. For this protocol, the value is TCP. The value can be entered in either uppercase or lowercase.

HOST is the host name or IP address.

PORT is the TCP/IP port number.

SERVICE_NAME the name of service on server; the database instance name may differ from the actual database name, but generally the names match.

DB_Alias any name of the connection

At the firs step select Oracle client HOME in Database home dropdown list and select database from the Database dropdown list. The databases names are taken from the tnsnames.ora file.